/*
Copyright (C) 2001, 2006 United States Government
as represented by the Administrator of the
National Aeronautics and Space Administration.
All Rights Reserved.
*/
package gov.nasa.worldwind.globes;

import gov.nasa.worldwind.*;
import gov.nasa.worldwind.avlist.*;

/**
 * @author Patrick Murris
 * @version $Id: Mars.java 9411 2009-03-16 21:03:25Z tgaskins $
 */

public class Mars extends EllipsoidalGlobe
{
    // From http://en.wikipedia.org/wiki/Mars
    public static final double EQUATORIAL_RADIUS = 3396200.0; // ellipsoid equatorial getRadius, in meters
    public static final double POLAR_RADIUS = 3376200.0; // ellipsoid polar getRadius, in meters
    public static final double ES = 0.00589; // eccentricity squared, semi-major axis

    public Mars()
    {
        super(EQUATORIAL_RADIUS, POLAR_RADIUS, ES, (ElevationModel)
        WorldWind.createComponentFromConfigurationFactory(AVKey.ELEVATION_MODEL_FACTORY,
            new String[]
                {
                    AVKey.MARS_ELEVATION_MODEL_CONFIG_FILE,
                    AVKey.MARS_ELEVATION_MODEL_CLASS_NAME
                }));
    }
}