/* Copyright (C) 2001, 2009 United States Government as represented by
the Administrator of the National Aeronautics and Space Administration.
All Rights Reserved.
*/
package gov.nasa.worldwind.render;

import gov.nasa.worldwind.geom.Sector;

/**
 * @author dcollins
 * @version $Id: SurfaceObject.java 11457 2009-06-05 07:09:37Z dcollins $
 */
public interface SurfaceObject
{
    boolean isVisible();

    void setVisible(boolean visible);

    long getLastModifiedTime();

    Iterable<? extends Sector> getSectors(DrawContext dc, double texelSizeRadians);

    void renderToRegion(DrawContext dc, Sector sector, int x, int y, int width, int height);
}
