/*
Copyright (C) 2001, 2008 United States Government
as represented by the Administrator of the
National Aeronautics and Space Administration.
All Rights Reserved.
*/

package gov.nasa.worldwind.render.markers;

import gov.nasa.worldwind.geom.Vec4;
import gov.nasa.worldwind.geom.Position;
import gov.nasa.worldwind.geom.Angle;
import gov.nasa.worldwind.render.Material;
import gov.nasa.worldwind.render.DrawContext;

/**
 * @author tag
 * @version $Id: Marker.java 5901 2008-08-09 23:35:00Z tgaskins $
 */
public interface Marker
{
    void render(DrawContext dc, Vec4 point, double radius);

    Position getPosition();

    void setPosition(Position position);

    MarkerAttributes getAttributes();

    void setAttributes(MarkerAttributes attributes);

    Angle getHeading();

    void setHeading(Angle heading);
}
