/*
Copyright (C) 2001, 2009 United States Government
as represented by the Administrator of the
National Aeronautics and Space Administration.
All Rights Reserved.
*/
package gov.nasa.worldwind.retrieve;

import gov.nasa.worldwind.NamedObject;
import gov.nasa.worldwind.geom.Sector;

/**
 * Can be retrieved with a bulk download thread.
 *
 * @author Patrick Murris
 * @version $Id: BulkRetrievable.java 10192 2009-04-14 21:12:31Z patrickmurris $
 */
public interface BulkRetrievable extends NamedObject
{
    BulkRetrievalThread makeLocal(Sector sector, double resolution);
    long getEstimatedMissingDataSize(Sector sector, double resolution);
}
